import React from 'react'
import styled from 'styled-components'
import { withJournal } from 'xpub-journal'
import { compose, withHandlers, withState } from 'recompose'

import AccountDetailsCard from './AccountDetailsCard'
import AccountDetailsEdit from './AccountDetailsEdit'

const AccountDetails = ({ user, isEdit, setEditMode, journal, history }) => (
  <Root>
    {isEdit ? (
      <AccountDetailsEdit
        journal={journal}
        setEditMode={setEditMode}
        user={user}
      />
    ) : (
      <AccountDetailsCard
        history={history}
        journal={journal}
        setEditMode={setEditMode}
        user={user}
      />
    )}
  </Root>
)

export default compose(
  withJournal,
  withState('isEdit', 'setEdit', false),
  withHandlers({
    setEditMode: ({ setEdit }) => value => () => setEdit(value),
  }),
)(AccountDetails)

// #region styles
const Root = styled.div`
  display: flex;
  flex-direction: column;
  max-width: 30em;
`
// #endregion
